// ,       http://www.interestprograms.ru
//


#pragma once
#include "background.h"
#include "cuberube.h"
#include "dimouse.h"
#include "controlbuttons.h"
#include "showdataplayers.h"




struct LVertex
{
    D3DXVECTOR3 v;
};

const DWORD VertexFVF = (D3DFVF_XYZ);


//   ,     Direct3D9. 
class CChildView : public CWnd
{
// Construction
public:
	CChildView();

protected:
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);

// Implementation
public:
	virtual ~CChildView();

	// Generated message map functions
protected:
	afx_msg void OnPaint();
	DECLARE_MESSAGE_MAP()

	
public:
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags);
	afx_msg void OnFullscreen();
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	  
	HRESULT InitD3D(void);
	HRESULT CreateDevice3D(void);
	HRESULT SetupMatrices();
	HRESULT ResetScene(void);
	//      3D  
	HRESULT GetBestParamsD3D(D3DPRESENT_PARAMETERS* d3dpp, D3DDEVTYPE* pDevType, DWORD* pVertexProccesing);
	HRESULT Render(void);
	
	
	//      
	//    .
	void FromDIMouse(int btindex);

	
	D3DXMATRIX m_World;
	D3DXMATRIX m_matView;
	D3DXMATRIX m_matProj;
	bool m_IsActive;

private:

	void SetPlayerName(void);
	void DataToRegistry(void);
	void DataFromRegistry(void);
	afx_msg void OnMenuHelp();
	
	LPDIRECT3D9 m_pD3D;
	LPDIRECT3DDEVICE9 m_pd3dDevice;

	CShowDataPlayers m_ShowDataPlayers;
	CBackground m_Background;
	CCubeRube m_CubeRube;
	CDIMouse m_DIMouse;
	CControlButtons m_ControlButtons;

	//      .
	BOOL m_IsRequestPlayerName;
	BOOL m_FullScreen;
	
};

